


$.fn.extend({
	/*
	+-----------------------------------------------

	<{div}><{/div}> ===> <div></div>
	防止 iframe 自行对返回字符进行处理
	
	利用iframe实现普通表单提交，支持文件上传
	$('form').form(function (data) {
		// code
	}, 'json');

	+-----------------------------------------------
	*/
	formSubmit: function(v) {
		if (jext.load[2]<1) {
			// jQ.alert('未准备就绪，稍后提交',2000);
			console.log(jext.load);
			return false;
		}
		var m = this;
		var v = window[m.attr('jextsubmitform')]||{};
		var type = v.dataType||'json';
		var method = v.type||m.attr('method')||'post';
		var action = v.url||m.attr('action')||'';
		// 跳过一些特殊提交方式
		if (m.is('[ie9fileupload]')) {
			return true;
		}
		// 验证提交令牌
		var vc = m.find('[name="VCodeID"]');
		if (m.attr('istokenok')!='1' && vc.size()) {
			if (m.attr('istokenok')=='2') return false;
			m.attr('istokenok','2');
			$.token(function(code) {
				vc.val(code);
				m.attr('istokenok','1').submit();
			});
			return false;
		}
		else m.attr('istokenok', '0');
		// 检验表单
		var m_che = m.check();
		if (!m_che && typeof(v.check)=='function') var che = v.check.call(m);
		if (m_che || (typeof(che)!=='undefined')&&!che) {
			return false;
		}
		m.find('input,textarea,select').blur(); //失去焦点，防止回车重复上传
		if (m.is('.issubmit')) {
			return false;
		}
		m.addClass('issubmit');
		// 记录信息
		m.remember(1);
		// 用于记录页面是否提交过表单，用完这个变量之后记得清0
		$.submitted();
		/*
		 * 表单上传
		 * 当存在文件上传的时候调用 iframe 上传
		**/
		if (m.find('input[type=file][name]').size()) {
			if (m.attr('target')) {
				return true;
			}
			var iframe = $('<iframe></iframe>').attr({name:'UFIframe', id:'UFIframe'}).css({display:'none'});
			$('html').append(iframe);
			m.attr({target:'UFIframe', method:method, enctype:'multipart/form-data'});
			iframe.iframe(function (data) {
				m.removeClass('issubmit');
				iframe.remove();
				if (type == 'json') {
					data = data.replace(/<\{/g, '<').replace(/\}>/g, '>');
					data = $.parseJSON(data);
				}
				if (typeof(v.end)=='function') v.end.call(m, data);
			});
			return true;
		}
		else {
			setTimeout(function() {
				$.ajax({
					url: action,
					dataType: type,
					type: method,
					data: m.serializeArray(),
					success: function (data) {
						m.removeClass('issubmit');
						if (typeof(v.end)=='function') v.end.call(m, data);
					},
					error: function () {
						m.removeClass('issubmit');
					}
				});
			}, 30);
			return false;
		}
	},

	// 记录表单的数据
	remember: function(submit) {
		var m = this;
		var remember = m.find('[name$="Remember"][type="checkbox"]');
		var rememberFor = remember.attr('for') || '';
		if (!remember.size()) return false;
		var dat = m.serializeArray();
		var datas = {};
		var datname = '';
		var input = 'input:not([name=VCodeID]),textarea';
		// 指定记录某些选项
		if (rememberFor) {
			rememberFor = rememberFor.split(/;|,/);
			input = 'inputfor';
			for (var i in rememberFor) {
				input += ',[name="' + rememberFor[i].trim() + '"]';
			}
		}
		m.find(input).each(function() {
			var a = $(this),
				n = a.attr('name'),
				v = a.val();
			datname += ',' + n;
			if (a.is('[type=checkbox]')) {
				if (a.is(':checked')) {
					datas[n] = datas[n] || [];
					datas[n].push(v);
				}
			} else if (a.is('[type=radio]')) {
				if (a.is(':checked')) {
					datas[n] = v;
				}
			} else {
				datas[n] = v;
			}
		});
		datname = 'Form' + datname;
		// 保存记录
		if (submit) {
			dat = JSON.stringify(datas);
			if (remember.is(':checked')) {
				$.cookie(datname, dat, 9999999999);
			}
			else {
				$.cookie(datname, '{}', 1);
			}
		}
		// 为记录赋值
		else {
			dat = $.json($.cookie(datname));
			if (Object.keys(dat).length !== 0) {
				remember.attr('checked', true);
			}
			for (var i in dat) {
				var inp = m.find('[name="' + i + '"]');
				if (inp.is('[type=checkbox]')) {
					for (var j in dat[i]) {
						m.find('[name="' + i + '"][value="' + dat[i][j] + '"]').attr('checked', true);
					}
				}
				else if (inp.is('[type=radio]')) {
					m.find('[name="' + i + '"][value="' + dat[i] + '"]').attr('checked', true);
				}
				else {
					inp.val(dat[i]);
				}
			}
		}
	},

	// 类型检测
	check: function(v) {
		var check = [],
			v = v || {},
			obj = this,
			email = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/,
			mobile = /^1[0-9]{10}$/,
			phone = /^\d{7,8}$/;
		obj.find('[check]:not([disabled])').each(function (i, e) {
			var isgo, type, val, num, name,
			one = $(this),
			sty = one.attr('check'),
			val = one.val() || '',
			tip = (one.dat('tip')||'').replace(/\{val\}/g, '"' + val + '"'),
			to  = one.is('[data-to]') ? $(one.attr('to')) : '';
			if (sty) {
				sty = sty.split('=');
				sty[0] = sty[0] == '' ? '=' : sty[0];
				sty[0] = sty[0].split('-');
				sty[0].length > 1 || sty[0].push(1);
				name = sty[1]||'';
				type = sty[0][0];
				num  = sty[0][1] = parseInt(sty[0][1]) || 1;
				if (type == 'str') {
					isgo = val.length >= num || -1;
				}
				else if (type == 'email') {
					isgo = email.test(val) || -1;
				}
				else if (type == 'mobile') {
					isgo = mobile.test(val) || -1;
				}
				else if (type == 'phone') {
					isgo = phone.test(val) || -1;
				}
				else if (type == '=') {
					isgo = val == obj.find('[name="' + name + '"]:last').val() || -1;
				}
				else if (type) {
					type = new RegExp(type);
					if (val.search(type) < 0) {
						isgo = -1;
					}
				}
				if (one.attr('type') == 'radio'||one.attr('type')=='checkbox') {
					isgo = $('[name="' + one.attr('name') + '"]:checked').length >= num || -1;
				}
				if (isgo == -1) {
					check.push({obj: one, tip: tip, to: to, type: type});
					to && to.html(tip).show();
				}
				if (one.attr('type') == 'radio' || one.attr('type') == 'checkbox') {
					one.parent().parent().on('click',function() {
						to && to.hide().html('');
					});
				}
				else {
					one.keyup(function() {
						to && to.hide().html('');
					});
				}
			}
		});
		if (check.length>0) {
			if (check[0].to) {
				check[0].to.html(check[0].tip);
			}
			else $.alert({
				str: check[0].tip,
				style: 'B',
				btn: 1
			});
		}
		return check.length > 0 ? check : 0;
	}
});

$('form').each(function(){
	$(this).remember();
});
